DROP VIEW VOTINGEUROPE.VIEW_R15_5;

CREATE OR REPLACE FORCE VIEW VOTINGEUROPE.VIEW_R15_5
(VOTES, ID_LOCALITY, DESCRIPTION, YEAR)
AS 
SELECT COUNT(ID_LOCALITY) AS VOTES, ID_LOCALITY, C.DESCRIPTION, EXTRACT (YEAR FROM D_END) AS YEAR
FROM V_LOG_VOTING A 
INNER JOIN V_CENSUS B ON
A.ID_CENSUS = B.ID
INNER JOIN V_LOCALITIES C ON
B.ID_LOCALITY = C.ID
INNER JOIN V_PROCESSES D ON
A.ID_PROCESS = D.ID
GROUP BY ID_LOCALITY, C.DESCRIPTION, EXTRACT (YEAR FROM D_END);


DROP VIEW VOTINGEUROPE.VIEW_R6_1;

CREATE OR REPLACE FORCE VIEW VOTINGEUROPE.VIEW_R6_1
(ID, ID_STATE, DESCRIPTION, D_START, D_END, 
 STATUS)
AS 
SELECT A.ID, B.ID_STATE, A.DESCRIPTION, A.D_START, A.D_END,
CASE 
    WHEN TO_DATE(D_PUBLISH,'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY') 
    AND TO_DATE(D_START,'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY')
    THEN 'W'
    WHEN TO_DATE(D_PUBLISH,'DD/MM/YYYY') <= TO_DATE(SYSDATE, 'DD/MM/YYYY') 
    AND TO_DATE(D_START,'DD/MM/YYYY') > TO_DATE(SYSDATE, 'DD/MM/YYYY')
    THEN 'P'
    WHEN TO_DATE(D_START,'DD/MM/YYYY')<= TO_DATE(SYSDATE, 'DD/MM/YYYY') 
    AND TO_DATE(D_END,'DD/MM/YYYY') >= TO_DATE(SYSDATE, 'DD/MM/YYYY') 
    THEN 'O'
    WHEN TO_DATE(D_END,'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY') 
    THEN 'F'
END AS STATUS 
FROM V_PROCESSES A 
LEFT JOIN V_REL_CENS_PROC B
ON A.ID = B.ID_PROCESS 
ORDER BY D_START, D_END, D_PUBLISH ASC;


DROP VIEW VOTINGEUROPE.VIEW_R6_2;

CREATE OR REPLACE FORCE VIEW VOTINGEUROPE.VIEW_R6_2
(TOTAL_CITIZENS, ID_PROCESS)
AS 
SELECT COUNT(A.ID) AS TOTAL_CITIZENS, B.ID_PROCESS
FROM V_CENSUS A
INNER JOIN V_REL_CENS_PROC B ON
(A.ID_STATE = B.ID_STATE OR A.ID_REGION = B.ID_REGION OR A.ID_LOCALITY = B.ID_LOCALITY)
GROUP BY ID_PROCESS;


DROP VIEW VOTINGEUROPE.VIEW_R6_3;

CREATE OR REPLACE FORCE VIEW VOTINGEUROPE.VIEW_R6_3
(ID_APPL, ID_APPLICATION, TOTAL_APPL, ID_PROC)
AS 
SELECT 
CASE WHEN D.D_END = TO_DATE('01/01/0001', 'DD/MM/YYYY') THEN '-'
ELSE  TO_CHAR(C.APPLICATION_ID)
END AS ID_APPL,
CASE WHEN D.D_END = TO_DATE('01/01/0001', 'DD/MM/YYYY') THEN '-'
ELSE  TO_CHAR(A.DESCRIPTION)
END AS DESCRIPTION,
CASE WHEN D.D_END = TO_DATE('01/01/0001', 'DD/MM/YYYY') THEN '-'
ELSE  TO_CHAR(COUNT(C.ID))
END AS TOTAL_VOTES, C.PROCESS_ID AS ID_PROC
FROM V_APPLICATIONS A
INNER JOIN V_REL_APPL_PROC B ON 
A.ID = B.ID_APPLICATION
INNER JOIN V_VOTES C ON
B.ID_PROCESS = C.PROCESS_ID
INNER JOIN V_PROCESSES D
ON D.ID = C.PROCESS_ID
WHERE 1 = 1
GROUP BY C.APPLICATION_ID, A.DESCRIPTION, D.D_END, C.PROCESS_ID
--ORDER BY COUNT(C.ID) DESC
;
