ALTER TABLE VOTINGEUROPE.V_APPLICATIONS
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_APPLICATIONS CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_APPLICATIONS
(
  ID              NUMBER,
  DESCRIPTION     VARCHAR2(4000 CHAR)           NOT NULL,
  CONTACT_PERSON  VARCHAR2(4000 CHAR),
  DETAILS         VARCHAR2(400 CHAR),
  ADDED_DOCS      BLOB,
  RESPONSIBLE     VARCHAR2(1000 CHAR),
  RESP_ADDRESS    VARCHAR2(1000 CHAR),
  RESP_PHONE      NUMBER,
  RESP_EMAIL      VARCHAR2(100 CHAR),
  D_SETUP         DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.CANDIDATURES_PK ON VOTINGEUROPE.V_APPLICATIONS
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_APPLICATIONS
BEFORE INSERT ON VOTINGEUROPE.V_APPLICATIONS
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_APPLICATIONS.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_APPLICATIONS ADD (
  CONSTRAINT CANDIDATURES_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.CANDIDATURES_PK
  ENABLE VALIDATE);
