ALTER TABLE VOTINGEUROPE.V_CENSUS
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_CENSUS CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_CENSUS
(
  ID             NUMBER,
  ID_STATE       NUMBER,
  ID_REGION      NUMBER,
  ID_LOCALITY    NUMBER,
  FIRST_NAME     VARCHAR2(100 CHAR),
  SURNAME        VARCHAR2(100 CHAR),
  OTHER_SURNAME  VARCHAR2(100 CHAR),
  ADDRESS        VARCHAR2(4000 CHAR),
  POSTAL_CODE    VARCHAR2(10 CHAR),
  BIRTH_DATE     DATE,
  DEATH_DATE     DATE,
  GENDER         VARCHAR2(1 CHAR),
  NATIONAL_ID    NUMBER,
  EMAIL          VARCHAR2(200 CHAR),
  PHONE_NUMBER   NUMBER
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_CENSUS_PK ON VOTINGEUROPE.V_CENSUS
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_CENSUS
BEFORE INSERT ON VOTINGEUROPE.V_CENSUS
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_CENSUS.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_CENSUS ADD (
  CONSTRAINT V_CENSUS_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_CENSUS_PK
  ENABLE VALIDATE);
