ALTER TABLE VOTINGEUROPE.V_LOCALITIES
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_LOCALITIES CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_LOCALITIES
(
  ID           NUMBER,
  ID_STATE     NUMBER                           NOT NULL,
  ID_REGION    NUMBER                           NOT NULL,
  DESCRIPTION  VARCHAR2(1000 CHAR)              NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_LOCALITIES_PK ON VOTINGEUROPE.V_LOCALITIES
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_LOCALITIES
BEFORE INSERT ON VOTINGEUROPE.V_LOCALITIES
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_LOCALITIES.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_LOCALITIES ADD (
  CONSTRAINT V_LOCALITIES_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_LOCALITIES_PK
  ENABLE VALIDATE);

ALTER TABLE VOTINGEUROPE.V_LOCALITIES ADD (
  CONSTRAINT V_LOCALITIES_R01 
  FOREIGN KEY (ID_STATE) 
  REFERENCES VOTINGEUROPE.V_STATES (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_LOCALITIES_R02 
  FOREIGN KEY (ID_REGION) 
  REFERENCES VOTINGEUROPE.V_REGIONS (ID)
  ENABLE VALIDATE);
