ALTER TABLE VOTINGEUROPE.V_LOG_PROCEDURES
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_LOG_PROCEDURES CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_LOG_PROCEDURES
(
  ID         NUMBER,
  PROC_NAME  VARCHAR2(100 CHAR)                 NOT NULL,
  S_INPUT    VARCHAR2(4000 CHAR),
  S_OUTPUT   VARCHAR2(4000 CHAR),
  ERR        VARCHAR2(1 CHAR),
  DESC_ERR   VARCHAR2(1000 CHAR),
  TIME_EXEC  DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_LOG_PROCEDURES_PK ON VOTINGEUROPE.V_LOG_PROCEDURES
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_LOG_PROCEDURES
BEFORE INSERT ON VOTINGEUROPE.V_LOG_PROCEDURES
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_LOG_PROCEDURES.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_LOG_PROCEDURES ADD (
  CONSTRAINT V_LOG_PROCEDURES_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_LOG_PROCEDURES_PK
  ENABLE VALIDATE);
