ALTER TABLE VOTINGEUROPE.V_LOG_VOTING
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_LOG_VOTING CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_LOG_VOTING
(
  ID          NUMBER,
  ID_PROCESS  NUMBER                            NOT NULL,
  ID_CENSUS   NUMBER                            NOT NULL,
  D_VOTING    DATE                              NOT NULL,
  STATUS      VARCHAR2(1 CHAR)
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


--  There is no statement for index VOTINGEUROPE.SYS_C007095.
--  The object is created when the parent object is created.

CREATE UNIQUE INDEX VOTINGEUROPE.V_LOG_VOTING_U01 ON VOTINGEUROPE.V_LOG_VOTING
(ID_PROCESS, ID_CENSUS)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_LOG_VOTING
BEFORE INSERT ON VOTINGEUROPE.V_LOG_VOTING
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_LOG_VOTING.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_LOG_VOTING ADD (
  PRIMARY KEY
  (ID)
  USING INDEX
    TABLESPACE USERS
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          64K
                NEXT             1M
                MINEXTENTS       1
                MAXEXTENTS       UNLIMITED
                PCTINCREASE      0
                BUFFER_POOL      DEFAULT
                FLASH_CACHE      DEFAULT
                CELL_FLASH_CACHE DEFAULT
               )
  ENABLE VALIDATE,
  CONSTRAINT V_LOG_VOTING_U01
  UNIQUE (ID_PROCESS, ID_CENSUS)
  USING INDEX VOTINGEUROPE.V_LOG_VOTING_U01
  ENABLE VALIDATE);

ALTER TABLE VOTINGEUROPE.V_LOG_VOTING ADD (
  CONSTRAINT V_LOG_VOTING_R01 
  FOREIGN KEY (ID_PROCESS) 
  REFERENCES VOTINGEUROPE.V_PROCESSES (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_LOG_VOTING_R02 
  FOREIGN KEY (ID_CENSUS) 
  REFERENCES VOTINGEUROPE.V_CENSUS (ID)
  ENABLE VALIDATE);
