ALTER TABLE VOTINGEUROPE.V_PROCESSES
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_PROCESSES CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_PROCESSES
(
  ID              NUMBER,
  DESCRIPTION     VARCHAR2(4000 CHAR)           NOT NULL,
  D_PUBLISH       DATE,
  D_START         DATE,
  D_END           DATE,
  PARTICIPATION   FLOAT(3),
  PRESIDENT_NAME  VARCHAR2(500 CHAR),
  URL             VARCHAR2(1000 CHAR)
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.PROCESES_PK ON VOTINGEUROPE.V_PROCESSES
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_PROCESES
BEFORE INSERT ON VOTINGEUROPE.V_PROCESSES
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_PROCESES.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_PROCESSES ADD (
  CONSTRAINT PROCESES_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.PROCESES_PK
  ENABLE VALIDATE);
