ALTER TABLE VOTINGEUROPE.V_REGIONS
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_REGIONS CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_REGIONS
(
  ID           NUMBER,
  ID_STATE     NUMBER,
  DESCRIPTION  VARCHAR2(1000 CHAR)
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_REGIONS_PK ON VOTINGEUROPE.V_REGIONS
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_REGIONS
BEFORE INSERT ON VOTINGEUROPE.V_REGIONS
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_REGIONS.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_REGIONS ADD (
  CONSTRAINT V_REGIONS_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_REGIONS_PK
  ENABLE VALIDATE);

ALTER TABLE VOTINGEUROPE.V_REGIONS ADD (
  CONSTRAINT V_REGIONS_R01 
  FOREIGN KEY (ID_STATE) 
  REFERENCES VOTINGEUROPE.V_STATES (ID)
  ENABLE VALIDATE);
