ALTER TABLE VOTINGEUROPE.V_REL_APPL_PROC
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_REL_APPL_PROC CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_REL_APPL_PROC
(
  ID              NUMBER                        NOT NULL,
  ID_APPLICATION  NUMBER                        NOT NULL,
  ID_PROCESS      NUMBER                        NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_REL_APPL_PROC_PK ON VOTINGEUROPE.V_REL_APPL_PROC
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE UNIQUE INDEX VOTINGEUROPE.V_REL_APPL_PROC_R01 ON VOTINGEUROPE.V_REL_APPL_PROC
(ID_APPLICATION, ID_PROCESS)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_REL_APPL_PROC
BEFORE INSERT ON VOTINGEUROPE.V_REL_APPL_PROC
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_REL_APPL_PROC.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_REL_APPL_PROC ADD (
  CONSTRAINT V_REL_APPL_PROC_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_REL_APPL_PROC_PK
  ENABLE VALIDATE,
  CONSTRAINT V_REL_APPL_PROC_R01
  UNIQUE (ID_APPLICATION, ID_PROCESS)
  USING INDEX VOTINGEUROPE.V_REL_APPL_PROC_R01
  ENABLE VALIDATE);
