ALTER TABLE VOTINGEUROPE.V_REL_CENS_PROC
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_REL_CENS_PROC CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_REL_CENS_PROC
(
  ID           NUMBER,
  ID_PROCESS   NUMBER                           NOT NULL,
  ID_STATE     NUMBER,
  ID_REGION    NUMBER,
  ID_LOCALITY  NUMBER
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_REL_CENS_PROC_PK ON VOTINGEUROPE.V_REL_CENS_PROC
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE UNIQUE INDEX VOTINGEUROPE.V_REL_CENS_PROC_U01 ON VOTINGEUROPE.V_REL_CENS_PROC
(ID_PROCESS, ID_STATE, ID_REGION, ID_LOCALITY)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_REL_CENS_PROC
BEFORE INSERT ON VOTINGEUROPE.V_REL_CENS_PROC
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_REL_CENS_PROC.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_REL_CENS_PROC ADD (
  CONSTRAINT V_REL_CENS_PROC_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_REL_CENS_PROC_PK
  ENABLE VALIDATE,
  CONSTRAINT V_REL_CENS_PROC_U01
  UNIQUE (ID_PROCESS, ID_STATE, ID_REGION, ID_LOCALITY)
  USING INDEX VOTINGEUROPE.V_REL_CENS_PROC_U01
  ENABLE VALIDATE);

ALTER TABLE VOTINGEUROPE.V_REL_CENS_PROC ADD (
  FOREIGN KEY (ID_PROCESS) 
  REFERENCES VOTINGEUROPE.V_PROCESSES (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_REL_CENS_PROC_R02 
  FOREIGN KEY (ID_STATE) 
  REFERENCES VOTINGEUROPE.V_STATES (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_REL_CENS_PROC_R03 
  FOREIGN KEY (ID_REGION) 
  REFERENCES VOTINGEUROPE.V_REGIONS (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_REL_CENS_PROC_R04 
  FOREIGN KEY (ID_LOCALITY) 
  REFERENCES VOTINGEUROPE.V_LOCALITIES (ID)
  ENABLE VALIDATE);
