ALTER TABLE VOTINGEUROPE.V_R_RESULTS
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_R_RESULTS CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_R_RESULTS
(
  ID_PROCESS      NUMBER,
  ID_WINNER       NUMBER,
  TOTAL_CITIZENS  NUMBER,
  PARTICIPATION   FLOAT(3),
  STATUS          VARCHAR2(1 CHAR),
  PORC_WINNER     FLOAT(3),
  ID_LESS         NUMBER,
  PORC_LESS       FLOAT(3),
  DIFF_MAX_MIN    FLOAT(3)
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_R_RESULTS_PK ON VOTINGEUROPE.V_R_RESULTS
(ID_PROCESS)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE VOTINGEUROPE.V_R_RESULTS ADD (
  CONSTRAINT V_R_RESULTS_PK
  PRIMARY KEY
  (ID_PROCESS)
  USING INDEX VOTINGEUROPE.V_R_RESULTS_PK
  ENABLE VALIDATE);

ALTER TABLE VOTINGEUROPE.V_R_RESULTS ADD (
  CONSTRAINT V_R_RESULTS_R01 
  FOREIGN KEY (ID_PROCESS) 
  REFERENCES VOTINGEUROPE.V_PROCESSES (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_R_RESULTS_R02 
  FOREIGN KEY (ID_WINNER) 
  REFERENCES VOTINGEUROPE.V_APPLICATIONS (ID)
  ENABLE VALIDATE);
