ALTER TABLE VOTINGEUROPE.V_STATES
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_STATES CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_STATES
(
  ID                 NUMBER,
  ISO_CODE           VARCHAR2(3 CHAR)           NOT NULL,
  DESCRIPTION        VARCHAR2(1000 CHAR),
  NAME_OWN_LANGUAGE  VARCHAR2(1000 CHAR)
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


--  There is no statement for index VOTINGEUROPE.SYS_C007083.
--  The object is created when the parent object is created.

CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_STATES
BEFORE INSERT ON VOTINGEUROPE.V_STATES
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_STATES.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_STATES ADD (
  PRIMARY KEY
  (ID)
  USING INDEX
    TABLESPACE USERS
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          64K
                NEXT             1M
                MINEXTENTS       1
                MAXEXTENTS       UNLIMITED
                PCTINCREASE      0
                BUFFER_POOL      DEFAULT
                FLASH_CACHE      DEFAULT
                CELL_FLASH_CACHE DEFAULT
               )
  ENABLE VALIDATE);
