ALTER TABLE VOTINGEUROPE.V_VOTES
 DROP PRIMARY KEY CASCADE;

DROP TABLE VOTINGEUROPE.V_VOTES CASCADE CONSTRAINTS;

CREATE TABLE VOTINGEUROPE.V_VOTES
(
  ID              NUMBER,
  PROCESS_ID      NUMBER,
  APPLICATION_ID  NUMBER,
  PERSON_HASHID   NUMBER,
  D_VOTING        DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX VOTINGEUROPE.V_VOTES_PK ON VOTINGEUROPE.V_VOTES
(ID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE UNIQUE INDEX VOTINGEUROPE.V_VOTES_U01 ON VOTINGEUROPE.V_VOTES
(PROCESS_ID, APPLICATION_ID, PERSON_HASHID)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE OR REPLACE TRIGGER VOTINGEUROPE.V_TR_VOTES
BEFORE INSERT ON VOTINGEUROPE.V_VOTES
FOR EACH ROW
BEGIN
SELECT VOTINGEUROPE.V_SQ_VOTES.NEXTVAL
INTO :new.ID
FROM dual;
END;
/


ALTER TABLE VOTINGEUROPE.V_VOTES ADD (
  CONSTRAINT V_VOTES_PK
  PRIMARY KEY
  (ID)
  USING INDEX VOTINGEUROPE.V_VOTES_PK
  ENABLE VALIDATE,
  CONSTRAINT V_VOTES_U01
  UNIQUE (PROCESS_ID, APPLICATION_ID, PERSON_HASHID)
  USING INDEX VOTINGEUROPE.V_VOTES_U01
  ENABLE VALIDATE);

ALTER TABLE VOTINGEUROPE.V_VOTES ADD (
  CONSTRAINT V_VOTES_R01 
  FOREIGN KEY (PROCESS_ID) 
  REFERENCES VOTINGEUROPE.V_PROCESSES (ID)
  ENABLE VALIDATE,
  CONSTRAINT V_VOTES_R02 
  FOREIGN KEY (APPLICATION_ID) 
  REFERENCES VOTINGEUROPE.V_APPLICATIONS (ID)
  ENABLE VALIDATE);
