--------------------------------------------------------
-- Archivo creado  - domingo-enero-15-2012   
--------------------------------------------------------
--------------------------------------------------------

DROP TYPE r6_1_tab;
DROP TYPE r6_1_obj;

create or replace type r6_1_obj is object (VOTING_NAME varchar2(100), START_DATE date, END_DATE date, TOTAL_CITIZENS number, 
PROCESS_STATUS varchar2(2), PARTICIPATION varchar2(100), WINNER_APPLICATION varchar2(100), PERCENT_WINNER varchar2(100));

create or replace type r6_1_tab is table of r6_1_OBJ;

DROP TYPE r6_b_tab;
DROP TYPE r6_b_obj;

create or replace type r6_b_obj is object (VOTING_NAME varchar2(100), START_DATE date, END_DATE date, WINNER VARCHAR2(100), 
PERCENT_WINNER varchar2(100), LOWER VARCHAR2(100), PERCENT_LOWER varchar2(100), DIFFERENCE varchar2(100));

create or replace type r6_b_tab is table of r6_b_OBJ;

DROP TYPE r6_c_tab;
DROP TYPE r6_c_obj;

create or replace type r6_c_obj is object (VOTING_NAME varchar2(100), START_DATE date, END_DATE date, WINNER VARCHAR2(100), 
PERCENT_WINNER varchar2(100), LOWER VARCHAR2(100), PERCENT_LOWER varchar2(100), DIFFERENCE varchar2(100));

create or replace type r6_c_tab is table of r6_c_OBJ;

DROP TYPE r6_d_tab;
DROP TYPE r6_d_obj;

create or replace type r6_d_obj is object (STATE varchar2(1000), REGION varchar2(1000), LOCALITY varchar2(1000));

create or replace type r6_d_tab is table of r6_d_OBJ;

DROP TYPE r6_e_tab;
DROP TYPE r6_e_obj;

create or replace type r6_e_obj is object (DESCRIPTION varchar2(1000), VOTED varchar2(10));

create or replace type r6_e_tab is table of r6_e_OBJ;



--  DDL for Function F_15_1
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_1" (INSTATE IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

    UPDATE_RESULTS(RSP);


SINPUT := CONCAT(INSTATE, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR);

select count(DISTINCT(A.id)) as total  INTO RET
from V_PROCESSES A 
INNER JOIN V_REL_CENS_PROC B ON A.ID = B.ID_PROCESS
LEFT JOIN V_STATES C ON B.ID_STATE = C.ID
LEFT JOIN V_REGIONS D ON B.ID_REGION = D.ID
LEFT JOIN V_LOCALITIES E ON B.ID_LOCALITY = E.ID
WHERE EXTRACT (YEAR FROM D_START) = INYEAR
AND (C.ID = INSTATE
OR D.ID_STATE = INSTATE
OR E.ID_STATE = INSTATE
);

    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_1',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_1',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_2_ALL
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_2_ALL" (INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);

SINPUT := INYEAR;

SELECT AVG(B.PARTICIPATION)*100 AS AVERAGE INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM D_END) = INYEAR
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_2_ALL',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_2_ALL',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_2_LOCALITY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_2_LOCALITY" (INID IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);
BEGIN

UPDATE_RESULTS(RSP);

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR);

SELECT AVG(B.PARTICIPATION)*100 AS AVERAGE INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM D_END) = INYEAR
AND C.ID_LOCALITY = INID
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_2_LOCALITY',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_2_LOCALITY',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_2_REGION
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_2_REGION" (INID IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);


SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR);

SELECT AVG(B.PARTICIPATION)*100 AS AVERAGE INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM D_END) = INYEAR
AND C.ID_REGION = INID
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_2_REGION',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_2_REGION',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_2_STATE
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_2_STATE" (INID IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR);


SELECT AVG(B.PARTICIPATION)*100 AS AVERAGE INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM D_END) = INYEAR
AND C.ID_STATE = INID
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_2_STATE',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_2_STATE',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_3_LOCALITY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_3_LOCALITY" (INID IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);


SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR);

SELECT COUNT(DISTINCT(A.ID)) AS TOTAL INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM A.D_START) = INYEAR
AND C.ID_LOCALITY = INID
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_3_LOCALITY',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_3_LOCALITY',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_3_REGION
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_3_REGION" (INID IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR);

SELECT COUNT(DISTINCT(A.ID)) AS TOTAL INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM A.D_START) = INYEAR
AND C.ID_REGION = INID
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_3_REGION',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_3_REGION',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_3_STATE
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_3_STATE" (INID IN NUMBER, INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;
SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INYEAR); 

SELECT COUNT(DISTINCT(A.ID)) AS TOTAL INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
INNER JOIN V_REL_CENS_PROC C
ON B.ID_PROCESS = C.ID_PROCESS
WHERE EXTRACT (YEAR FROM A.D_START) = INYEAR
AND C.ID_STATE = INID
;

RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_3_STATE',SINPUT,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_3_STATE',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_4
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_4" (INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

UPDATE_RESULTS(RSP);

SELECT A.ID INTO RET
FROM V_PROCESSES A
INNER JOIN V_R_RESULTS B
ON A.ID = B.ID_PROCESS
WHERE EXTRACT (YEAR FROM A.D_START) = INYEAR
ORDER BY B.PARTICIPATION DESC
;

    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_4',INYEAR,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_4',INYEAR,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_5
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_5" (INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

UPDATE_RESULTS(RSP);

SELECT ID_LOCALITY INTO RET 
FROM VIEW_R15_5 A 
WHERE VOTES = (SELECT MAX(VOTES) 
FROM VIEW_R15_5 WHERE YEAR = INYEAR)
;

    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_5',INYEAR,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_5',INYEAR,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_6
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_6" (INYEAR IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

UPDATE_RESULTS(RSP);

SELECT (1 - (
SELECT COUNT(ID) VOTED 
FROM V_LOG_VOTING
WHERE EXTRACT (YEAR FROM D_VOTING) <= INYEAR)/TOTAL_CITIZENS)* 100 AS NO_VOTED INTO RET
FROM V_R_RESULTS 
;

    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_6',INYEAR,RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_6',INYEAR,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_7
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_7" (RSP OUT VARCHAR)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

UPDATE_RESULTS(RSP);

SELECT  A.ID_PROCESS AS VOTACIO_PLUS INTO RET
FROM V_R_RESULTS A
WHERE PARTICIPATION = (SELECT MAX(PARTICIPATION) FROM V_R_RESULTS) 
;

    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_7','-',RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_7','-','ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_8
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_8" (RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

UPDATE_RESULTS(RSP);


SELECT COUNT(ID_PROCESS) AS PROCESS INTO RET
 FROM V_R_RESULTS A WHERE DIFF_MAX_MIN = (SELECT MAX(DIFF_MAX_MIN) FROM V_R_RESULTS)
 AND ID_PROCESS IN (SELECT ID FROM V_PROCESSES WHERE TO_DATE(D_END, 'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY'))
;

    IF RET = 1 THEN
    SELECT ID_PROCESS AS PROCESS INTO RET
     FROM V_R_RESULTS A WHERE DIFF_MAX_MIN = (SELECT MAX(DIFF_MAX_MIN) FROM V_R_RESULTS)
     AND ID_PROCESS IN (SELECT ID FROM V_PROCESSES WHERE TO_DATE(D_END, 'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY'))
    ;
    ELSE
        RET := 0;
    END IF;
    
    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_8','-',RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_8','-','ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_15_9
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_15_9" (RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

UPDATE_RESULTS(RSP);

SELECT COUNT(ID_PROCESS) AS PROCESS INTO RET
 FROM V_R_RESULTS A WHERE DIFF_MAX_MIN = (SELECT MIN(DIFF_MAX_MIN) FROM V_R_RESULTS)
 AND ID_PROCESS IN (SELECT ID FROM V_PROCESSES WHERE TO_DATE(D_END, 'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY'))
;

    IF RET = 1 THEN
    SELECT ID_PROCESS AS PROCESS INTO RET
     FROM V_R_RESULTS A WHERE DIFF_MAX_MIN = (SELECT MIN(DIFF_MAX_MIN) FROM V_R_RESULTS)
     AND ID_PROCESS IN (SELECT ID FROM V_PROCESSES WHERE TO_DATE(D_END, 'DD/MM/YYYY') < TO_DATE(SYSDATE, 'DD/MM/YYYY'))
    ;
    ELSE
        RET := 0;
    END IF;

    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_15_9','-',RET,'N','-');
    COMMIT;
     
    return RET;
    
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);  
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_15_9','-','ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;

RETURN RET;
END;

/
--------------------------------------------------------
--  DDL for Function F_LOWER_OPTION
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_LOWER_OPTION" (INID_PROCESS IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

   SELECT COUNT(ID_APPL) INTO RET FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS AND TOTAL_APPL IN (SELECT MIN(TOTAL_APPL) FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS);

    IF RET =1 THEN
        sELECT ID_APPL INTO RET FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS AND TOTAL_APPL IN (SELECT MIN(TOTAL_APPL) FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS);
    ELSE
        RET := 0;
    END IF;
    
    IF SQL%NOTFOUND THEN
    RET := 0; 
    END IF;
    
    INSERT_LOG_PROCEDURES('F_LOWER_OPTION',INID_PROCESS,RET,'N','-');
    COMMIT;
    RSP:= 'OK';

RETURN RET;

EXCEPTION WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('F_LOWER_OPTION',INID_PROCESS,'ERR','Y',SQLERRM);
    COMMIT;
    RET := -1;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Function F_R6_A
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_R6_A" (INID IN NUMBER) return r6_1_tab
  is
     l_r6_1 r6_1_tab := r6_1_tab();
     n integer := 0;
     RSP VARCHAR2(10);
  begin
  
      UPDATE_RESULTS(RSP);

     
     for r in (select c.description as a1, c.d_start as a2, c.d_end as a3, b.total_citizens as a4, b.status as a5, 
case when D_END < SYSDATE THEN TO_CHAR(B.PARTICIPATION) ELSE '-' END AS a6, 
case when D_END < SYSDATE THEN TO_CHAR((SELECT DESCRIPTION FROM V_APPLICATIONS WHERE ID = B.ID_WINNER)) ELSE '-' END AS a7,
case when D_END < SYSDATE THEN TO_CHAR(B.PORC_WINNER) ELSE '-' END AS a8
from v_rel_cens_proc a
inner join v_r_results b 
on a.id_process = B.ID_PROCESS
inner join v_processes c
on b.id_process = c.id
where a.id_state = INID
or a.id_region in (select id from v_regions where id_state = INID)
or a.id_locality in (select id from v_localities where id_state = INID)
ORDER BY D_START ASC
)
     loop
        l_r6_1.extend;
        n := n + 1;
       l_r6_1(n) := r6_1_OBJ(r.a1, r.a2, r.a3, r.a4, r.a5, r.a6, r.a7, r.a8);
     end loop;
    
    
    RSP := 'OK';
    return l_r6_1;
    INSERT_LOG_PROCEDURES('F_R6_A',INID,RSP,'N','-');

EXCEPTION WHEN OTHERS THEN
    RSP := 'ERR';
    INSERT_LOG_PROCEDURES('F_R6_A',INID,RSP,'Y',SQLERRM);
end;

/
--------------------------------------------------------
--  DDL for Function F_R6_B
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_R6_B" return r6_b_tab
  is
     l_r6_b r6_b_tab := r6_b_tab();
     n integer := 0;
     RSP VARCHAR(10);
  begin
  
  UPDATE_RESULTS(RSP);

     for r in (
     SELECT B.DESCRIPTION A1,B.D_START A2, B.D_END A3, 
(SELECT DESCRIPTION FROM V_APPLICATIONS WHERE ID = A.ID_WINNER) AS A4,
PORC_WINNER*100 AS A5,
(SELECT DESCRIPTION FROM V_APPLICATIONS WHERE ID = A.ID_LESS) AS A6,
PORC_LESS*100 AS A7,
(A.PORC_WINNER - A.PORC_LESS)*100 AS A8
FROM V_R_RESULTS A 
INNER JOIN V_PROCESSES B 
ON 
A.ID_PROCESS = B.ID
WHERE ROWNUM <= 10
ORDER BY A.PORC_WINNER - A.PORC_LESS DESC
)
     loop
        l_r6_b.extend;
        n := n + 1;
       l_r6_b(n) := r6_b_OBJ(r.a1, r.a2, r.a3, r.a4, r.a5, r.a6, r.a7, r.a8);
     end loop;
     
     RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_R6_B','-',RSP,'N','-');
    
    
    return l_r6_b;
EXCEPTION WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('F_R6_B','-','ERR','Y',SQLERRM);
    
    RSP := 'ERR';  
end;

/
--------------------------------------------------------
--  DDL for Function F_R6_C
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_R6_C" return r6_c_tab
  is
     l_r6_c r6_c_tab := r6_c_tab();
     n integer := 0;
     RSP VARCHAR2(10);
  begin
  
  UPDATE_RESULTS(RSP);

     for r in (
     SELECT B.DESCRIPTION A1,B.D_START A2, B.D_END A3, 
(SELECT DESCRIPTION FROM V_APPLICATIONS WHERE ID = A.ID_WINNER) AS A4,
PORC_WINNER*100 AS A5,
(SELECT DESCRIPTION FROM V_APPLICATIONS WHERE ID = A.ID_LESS) AS A6,
PORC_LESS*100 AS A7,
(A.PORC_WINNER - A.PORC_LESS)*100 AS A8
FROM V_R_RESULTS A 
INNER JOIN V_PROCESSES B 
ON 
A.ID_PROCESS = B.ID
WHERE ROWNUM <= 10
ORDER BY A.PORC_WINNER - A.PORC_LESS ASC
)
     loop
        l_r6_c.extend;
        n := n + 1;
       l_r6_c(n) := r6_c_OBJ(r.a1, r.a2, r.a3, r.a4, r.a5, r.a6, r.a7, r.a8);
     end loop;
     
    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_R6_C','-',RSP,'N','-');
    
    return l_r6_c;
    
EXCEPTION WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('F_R6_C','-','ERR','Y',SQLERRM);
    
    RSP := 'ERR';
end;

/
--------------------------------------------------------
--  DDL for Function F_R6_D
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_R6_D" (INID IN NUMBER) return r6_d_tab
  is
     l_r6_d r6_d_tab := r6_d_tab();
     n integer := 0;
     RSP VARCHAR2(10);
     
  begin
  
  UPDATE_RESULTS (RSP);

     for r in (
     select (select DESCRIPTION FROM V_STATES WHERE ID = A.ID_STATE) AS STATE,
(select DESCRIPTION FROM V_REGIONS WHERE ID = A.ID_REGION) AS REGION,
(select DESCRIPTION FROM V_LOCALITIES WHERE ID = A.ID_LOCALITY) AS LOCALITY
 from v_census A
WHERE ID = INID
)
     loop
        l_r6_d.extend;
        n := n + 1;
       l_r6_d(n) := r6_d_OBJ(r.STATE, r.REGION, r.LOCALITY);
     end loop;
     
    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_R6_D',INID,RSP,'N','-');
    return l_r6_d;
    
    
EXCEPTION WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('F_R6_D',INID,'ERR','Y',SQLERRM);
    RSP := 'ERR';
end;

/
--------------------------------------------------------
--  DDL for Function F_R6_E
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_R6_E" (INID IN NUMBER) return r6_e_tab
  is
     l_r6_e r6_e_tab := r6_e_tab();
     n integer := 0;
     RSP VARCHAR2(10);
  begin
  
  UPDATE_RESULTS(RSP);

     for r in (
SELECT A.ID, DESCRIPTION , CASE WHEN 
(SELECT STATUS FROM V_LOG_VOTING WHERE ID_PROCESS = A.ID AND ID_CENSUS = INID) = 'Y' THEN 'YES' ELSE 'NO' END AS VOTED
FROM V_PROCESSES A 
INNER JOIN V_REL_CENS_PROC B ON A.ID = B.ID_PROCESS
INNER JOIN V_CENSUS C ON
(B.ID_STATE = C.ID_STATE OR B.ID_REGION = C.ID_REGION OR B.ID_LOCALITY = C.ID_LOCALITY)
WHERE C.ID = INID
)
     loop
        l_r6_e.extend;
        n := n + 1;
       l_r6_e(n) := r6_e_OBJ(r.DESCRIPTION, r.VOTED);
     end loop;
    
    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_R6_E',INID,RSP,'N','-');
     
    return l_r6_e;
    
EXCEPTION WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('F_R6_E',INID,'ERR','Y',SQLERRM);
    RSP := 'ERR';
end;

/
--------------------------------------------------------
--  DDL for Function F_WINNER_OPTION
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "VOTINGEUROPE"."F_WINNER_OPTION" (INID_PROCESS IN NUMBER, RSP OUT VARCHAR2)
RETURN NUMBER 
IS 
RET NUMBER;

BEGIN

  
   SELECT count(ID_APPL) INTO RET FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS AND TOTAL_APPL IN (SELECT MAX(TOTAL_APPL) FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS);
    IF RET =1 THEN
        SELECT ID_APPL INTO RET FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS AND TOTAL_APPL IN (SELECT MAX(TOTAL_APPL) FROM VIEW_R6_3 WHERE ID_PROC = INID_PROCESS);
    ELSE
        RET := 0;
    END IF;
    
    
    RSP:= 'OK';
    INSERT_LOG_PROCEDURES('F_WINNER_OPTION',INID_PROCESS,RSP,'N','-');
    COMMIT;
    
RETURN RET;
EXCEPTION WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('F_WINNER_OPTION',INID_PROCESS,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    RET := -1;
END;

/
