--------------------------------------------------------
-- Archivo creado  - domingo-enero-15-2012   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Procedure DELETE_APPLICATIONS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_APPLICATIONS" (INID IN NUMBER,
RSP OUT VARCHAR)
IS

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

SELECT COUNT(ID) INTO NID FROM V_APPLICATIONS A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;


DELETE FROM V_APPLICATIONS WHERE ID = INID;
COMMIT;



INSERT_LOG_PROCEDURES('DELETE_APPLICATIONS',INID,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_APPLICATIONS',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');

WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE(SQLERRM);
ROLLBACK;

INSERT_LOG_PROCEDURES('DELETE_APPLICATIONS',INID,'ERR','Y',SQLERRM);
COMMIT;
RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_CENSUS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_CENSUS" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

SELECT COUNT(ID) INTO NID FROM V_CENSUS A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;


DELETE FROM V_CENSUS WHERE ID = INID;
COMMIT;


INSERT_LOG_PROCEDURES('DELETE_CENSUS',INID,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_CENSUS',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');

WHEN OTHERS THEN
    
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_CENSUS',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_LOCALITIES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_LOCALITIES" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

    SELECT COUNT(ID) INTO NID FROM V_LOCALITIES A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;

    DELETE FROM V_LOCALITIES WHERE ID = INID;
    COMMIT;
    
INSERT_LOG_PROCEDURES('DELETE_LOCALITIES',INID,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_LOCALITIES',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_LOCALITIES',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_PROCESSES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_PROCESSES" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

    SELECT COUNT(ID) INTO NID FROM V_PROCESSES A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;


DELETE FROM V_PROCESSES WHERE ID = INID;
COMMIT;

INSERT_LOG_PROCEDURES('DELETE_PROCESSES',INID,'OK','N','-');
COMMIT;
RSP := 'OK';


EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_PROCESSES',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_PROCESSES',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_REGIONS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_REGIONS" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

    SELECT COUNT(ID) INTO NID FROM V_REGIONS A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;

DELETE FROM V_REGIONS WHERE ID = INID;
COMMIT;


IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('DELETE_REGIONS',INID,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_REGIONS',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');


WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_REGIONS',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_REL_APPL_PROC
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_REL_APPL_PROC" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

    SELECT COUNT(ID) INTO NID FROM V_REL_APPL_PROC A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;


DELETE FROM V_REL_APPL_PROC WHERE ID = INID;
COMMIT;


IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('DELETE_REL_APPL_PROC',INID,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_REL_APPL_PROC',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');



WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_REL_APPL_PROC',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_REL_CENS_PROC
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_REL_CENS_PROC" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

    SELECT COUNT(ID) INTO NID FROM V_REL_CENS_PROC A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;


DELETE FROM V_REL_CENS_PROC WHERE ID = INID;
COMMIT;

IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('DELETE_REL_CENS_PROC',INID,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_REL_CENS_PROC',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');


WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_REL_CENS_PROC',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure DELETE_STATES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."DELETE_STATES" (INID IN NUMBER,
RSP OUT VARCHAR)
IS 

NID NUMBER;
NOT_FOUND EXCEPTION;

BEGIN

    SELECT COUNT(ID) INTO NID FROM V_STATES A WHERE A.ID = INID;
    COMMIT;

    IF NID <> 1 THEN
        RAISE NOT_FOUND;
    END IF;

DELETE FROM V_STATES WHERE ID = INID;
COMMIT;


IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('DELETE_STATES',INID,'OK','N','-');
COMMIT;
RSP := 'OK';


EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('DELETE_STATES',INID,'ERR','Y','ID NOT FOUND');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'ID NOT FOUND');

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('DELETE_STATES',INID,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_APPLICATIONS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_APPLICATIONS" (INDESCRIPTION IN VARCHAR2, INCONTACT_PERSON IN VARCHAR2,
INDETAILS IN VARCHAR2, INADDED_DOCS IN BLOB, INRESPONSIBLE IN VARCHAR2, INRESP_ADDRESS IN VARCHAR2, 
INRESP_PHONE IN NUMBER, INRESP_EMAIL IN VARCHAR
,RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INDESCRIPTION, SAUX);
SINPUT := CONCAT(SINPUT,INCONTACT_PERSON);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDETAILS);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESPONSIBLE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESP_ADDRESS);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESP_PHONE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESP_EMAIL);

INSERT INTO VOTINGEUROPE.V_APPLICATIONS (
   DESCRIPTION, CONTACT_PERSON, 
   DETAILS, ADDED_DOCS, RESPONSIBLE, 
   RESP_ADDRESS, RESP_PHONE, RESP_EMAIL, 
   D_SETUP) 
VALUES ( 
  INDESCRIPTION ,
  INCONTACT_PERSON ,
  INDETAILS ,
  INADDED_DOCS ,
  INRESPONSIBLE ,
  INRESP_ADDRESS ,
  INRESP_PHONE ,
  INRESP_EMAIL ,
  TO_DATE(SYSDATE, 'DD/MM/YYYY')
  );


COMMIT;
INSERT_LOG_PROCEDURES('INSERT_APPLICATIONS',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE(SQLERRM);
ROLLBACK;

INSERT_LOG_PROCEDURES('DELETE_APPLICATIONS',SINPUT,'ERR','Y',SQLERRM);
COMMIT;
RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_CENSUS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_CENSUS" (INID_STATE IN NUMBER, INID_REGION IN NUMBER,
INID_LOCALITY IN NUMBER, INFIRST_NAME IN VARCHAR2, INSURNAME IN VARCHAR2, INOTHER_SURNAME IN VARCHAR2, 
INADDRESS IN VARCHAR2, INPOSTAL_CODE IN VARCHAR2, INBIRTH_DATE IN DATE, INDEATH_DATE IN DATE, INGENDER IN VARCHAR2, 
INNATIONAL_ID IN NUMBER, INEMAIL IN VARCHAR2, INPHONE_NUMBER IN NUMBER,
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID_STATE, SAUX);
SINPUT := CONCAT(SINPUT,INID_REGION); SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INID_LOCALITY); SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INFIRST_NAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INSURNAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INOTHER_SURNAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INADDRESS);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPOSTAL_CODE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INBIRTH_DATE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDEATH_DATE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INGENDER);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INNATIONAL_ID);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INEMAIL);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPHONE_NUMBER);

INSERT INTO VOTINGEUROPE.V_CENSUS (
   ID_STATE, ID_REGION, 
   ID_LOCALITY, FIRST_NAME, SURNAME, 
   OTHER_SURNAME, ADDRESS, POSTAL_CODE, 
   BIRTH_DATE, DEATH_DATE, GENDER, 
   NATIONAL_ID, EMAIL, PHONE_NUMBER) 
VALUES (
  INID_STATE ,
  INID_REGION ,
  INID_LOCALITY ,
  INFIRST_NAME ,
  INSURNAME ,
  INOTHER_SURNAME ,
  INADDRESS ,
  INPOSTAL_CODE ,
  INBIRTH_DATE ,
  INDEATH_DATE ,
  INGENDER ,
  INNATIONAL_ID ,
  INEMAIL ,
  INPHONE_NUMBER );


COMMIT;
INSERT_LOG_PROCEDURES('INSERT_CENSUS',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE(SQLERRM);
ROLLBACK;

INSERT_LOG_PROCEDURES('DELETE_CENSUS',SINPUT,'ERR','Y',SQLERRM);
COMMIT;
RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_VOTES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_VOTES" (INPROCESS_ID IN NUMBER, INAPPLICATION_ID IN NUMBER, 
INPERSON_HASHID IN NUMBER, IND_VOTING IN DATE,
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INPROCESS_ID, SAUX);
SINPUT := CONCAT(SINPUT,INAPPLICATION_ID);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPERSON_HASHID);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_VOTING);

INSERT INTO VOTINGEUROPE.V_VOTES (
   PROCESS_ID, APPLICATION_ID, 
   PERSON_HASHID, D_VOTING) 
VALUES (
  INPROCESS_ID ,
  INAPPLICATION_ID ,
  INPERSON_HASHID ,
  IND_VOTING  );
  
  
COMMIT;
    INSERT_LOG_PROCEDURES('INSERT_VOTES',SINPUT,'OK','N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_VOTES',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_CENSUS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_CENSUS" (INID IN NUMBER, INID_STATE IN NUMBER, INID_REGION IN NUMBER,
INID_LOCALITY IN NUMBER, INFIRST_NAME IN VARCHAR2, INSURNAME IN VARCHAR2, INOTHER_SURNAME IN VARCHAR2, 
INADDRESS IN VARCHAR2, INPOSTAL_CODE IN VARCHAR2, INBIRTH_DATE IN DATE, INDEATH_DATE IN DATE, INGENDER IN VARCHAR2, 
INNATIONAL_ID IN NUMBER, INEMAIL IN VARCHAR2, INPHONE_NUMBER IN NUMBER,
RSP OUT VARCHAR)
IS 

NOT_FOUND EXCEPTION;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INID_STATE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INID_REGION); SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INID_LOCALITY); SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INFIRST_NAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INSURNAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INOTHER_SURNAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INADDRESS);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPOSTAL_CODE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INBIRTH_DATE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDEATH_DATE);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INGENDER);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INNATIONAL_ID);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INEMAIL);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPHONE_NUMBER);

IF INID_STATE IS NOT NULL THEN
    UPDATE V_CENSUS SET ID_STATE = INID_STATE
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INID_REGION IS NOT NULL THEN
    UPDATE V_CENSUS SET ID_REGION = INID_REGION
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INID_LOCALITY IS NOT NULL THEN
    UPDATE V_CENSUS SET ID_LOCALITY = INID_LOCALITY
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INFIRST_NAME IS NOT NULL THEN
    UPDATE V_CENSUS SET FIRST_NAME = INFIRST_NAME
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INSURNAME IS NOT NULL THEN
    UPDATE V_CENSUS SET SURNAME = INSURNAME
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INOTHER_SURNAME IS NOT NULL THEN
    UPDATE V_CENSUS SET OTHER_SURNAME = INOTHER_SURNAME
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INADDRESS IS NOT NULL THEN
    UPDATE V_CENSUS SET ADDRESS = INADDRESS
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INPOSTAL_CODE IS NOT NULL THEN
    UPDATE V_CENSUS SET POSTAL_CODE = INPOSTAL_CODE
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INBIRTH_DATE IS NOT NULL THEN
    UPDATE V_CENSUS SET BIRTH_DATE = INBIRTH_DATE
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INDEATH_DATE IS NOT NULL THEN
    UPDATE V_CENSUS SET DEATH_DATE = INDEATH_DATE
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INGENDER IS NOT NULL THEN
    UPDATE V_CENSUS SET GENDER = INGENDER
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INNATIONAL_ID IS NOT NULL THEN
    UPDATE V_CENSUS SET NATIONAL_ID = INNATIONAL_ID
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INEMAIL IS NOT NULL THEN
    UPDATE V_CENSUS SET EMAIL = INEMAIL
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF INPHONE_NUMBER IS NOT NULL THEN
    UPDATE V_CENSUS SET PHONE_NUMBER = INPHONE_NUMBER
    WHERE V_CENSUS.ID = INID;
    COMMIT;
END IF;

IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('UPDATE_CENSUS',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';


EXCEPTION 
    
   WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('UPDATE_CENSUS',SINPUT,'ERR','Y','NO ROWS UPDATED');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'NO ROWS UPDATED');

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('UPDATE_CENSUS',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';

END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_LOCALITIES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_LOCALITIES" ( INID_STATE IN NUMBER, 
INID_REGION IN NUMBER, INDESCRIPTION IN VARCHAR2,
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);


BEGIN

SINPUT := CONCAT(INID_STATE, SAUX);
SINPUT := CONCAT(SINPUT,INID_REGION);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDESCRIPTION);

INSERT INTO VOTINGEUROPE.V_LOCALITIES (
   ID_STATE, ID_REGION, 
   DESCRIPTION) 
VALUES (
  INID_STATE ,
  INID_REGION ,
  INDESCRIPTION );

COMMIT;
INSERT_LOG_PROCEDURES('INSERT_LOCALITIES',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE(SQLERRM);
ROLLBACK;

INSERT_LOG_PROCEDURES('INSERT_LOCALITIES',SINPUT,'ERR','Y',SQLERRM);
COMMIT;
RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_REGIONS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_REGIONS" (INID_STATE IN NUMBER, INDESCRIPTION IN VARCHAR2,
RSP OUT VARCHAR)
IS 


SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID_STATE, SAUX); SINPUT := CONCAT(SINPUT,INDESCRIPTION);

INSERT INTO VOTINGEUROPE.V_REGIONS (
    ID_STATE, DESCRIPTION) 
VALUES (
  INID_STATE ,
  INDESCRIPTION );
  
COMMIT;
    INSERT_LOG_PROCEDURES('INSERT_REGIONS',SINPUT,'OK','N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_REGIONS',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_PROCESSES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_PROCESSES" (INDESCRIPTION IN VARCHAR2, 
IND_PUBLISH IN DATE, IND_START IN DATE, IND_END IN DATE, INPRESIDENT_NAME IN VARCHAR2,
INURL IN VARCHAR2, RSP OUT VARCHAR2)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);
WRONG_DATES EXCEPTION;
SMSG VARCHAR2(1000);

BEGIN

SINPUT := CONCAT(INDESCRIPTION, SAUX);
SINPUT := CONCAT(SINPUT,IND_PUBLISH);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_START);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_END);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPRESIDENT_NAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INURL);



IF (IND_PUBLISH = '01/01/0001' OR IND_START = '01/01/0001' AND IND_END = '01/01/0001') 
THEN
    SMSG:= 'WRONG DATES: PUBISH DATE, START DATE AND END DATE MUST BE INFORMED';
    RAISE WRONG_DATES;
END IF;


IF (IND_PUBLISH <> '01/01/0001' AND IND_START <> '01/01/0001' AND IND_END <> '01/01/0001')
THEN
    IF  (IND_END < IND_START OR (IND_START - 7 > IND_PUBLISH)) 
        THEN 
        SMSG:= 'WRONG DATES: PUBISH DATE MUST BE AT LEAST 7 DAYS BEFORE START DATE AND END DATE MUST BE AFTER START DATE';
            RAISE WRONG_DATES;
            
    END IF; 
    RSP:= 'OK';
END IF;



INSERT INTO VOTINGEUROPE.V_PROCESSES 
(
   DESCRIPTION, 
   D_PUBLISH, 
   D_START, 
   D_END, 
   PARTICIPATION, 
   PRESIDENT_NAME, 
   URL) 
VALUES ( 
    INDESCRIPTION,
    IND_PUBLISH,
    IND_START ,
    IND_END ,
    0.0,
    INPRESIDENT_NAME ,
    INURL  );

    COMMIT;
    INSERT_LOG_PROCEDURES('INSERT_PROCESSES',SINPUT,'OK','N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN WRONG_DATES THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_PROCESSES',SINPUT,'ERR','Y',SMSG);
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999,SMSG);
    
WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_PROCESSES',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure P_15_10
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."P_15_10" (INID_CENSUS IN NUMBER, RSP OUT VARCHAR, OUTTOTAL OUT NUMBER, OUTSTATE OUT VARCHAR2)
IS

SAUX VARCHAR(3):= ' , ';
SOUTPUT VARCHAR2(4000);

BEGIN

UPDATE_RESULTS(RSP);


SELECT COUNT(DISTINCT(ID_PROCESS)) AS TOT_PROCESSES, (SELECT DESCRIPTION FROM V_STATES WHERE ID = B.ID_STATE) AS STATE  
INTO OUTTOTAL, OUTSTATE 
FROM V_LOG_VOTING A
INNER JOIN V_CENSUS B ON A.ID_CENSUS = B.ID
WHERE ID_CENSUS = INID_CENSUS
GROUP BY B.ID_STATE
;

SOUTPUT := CONCAT(OUTTOTAL, SAUX);
SOUTPUT := CONCAT(SOUTPUT,OUTSTATE);

COMMIT;
    INSERT_LOG_PROCEDURES('P_15_10',INID_CENSUS,SOUTPUT,'N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('P_15_10',INID_CENSUS,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_PROCESSES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_PROCESSES" (INID IN NUMBER, INDESCRIPTION IN VARCHAR2, 
IND_PUBLISH IN DATE, IND_START IN DATE, IND_END IN DATE, INPRESIDENT_NAME IN VARCHAR2,
INURL IN VARCHAR2,
RSP OUT VARCHAR)
IS 

NOT_FOUND EXCEPTION;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

WRONG_DATES EXCEPTION;
SMSG VARCHAR2(1000);

BEGIN

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INDESCRIPTION);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_PUBLISH);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_START);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_END);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_START);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INPRESIDENT_NAME);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INURL);


IF (IND_PUBLISH = '01/01/0001' OR IND_START = '01/01/0001' AND IND_END = '01/01/0001') 
THEN
    SMSG:= 'WRONG DATES: PUBISH DATE, START DATE AND END DATE MUST BE INFORMED';
    RAISE WRONG_DATES;
END IF;


IF (IND_PUBLISH <> '01/01/0001' AND IND_START <> '01/01/0001' AND IND_END <> '01/01/0001')
THEN
    IF  (IND_END < IND_START OR (IND_START - 7 > IND_PUBLISH)) 
        THEN 
        SMSG:= 'WRONG DATES: PUBISH DATE MUST BE AT LEAST 7 DAYS BEFORE START DATE AND END DATE MUST BE AFTER START DATE';
            RAISE WRONG_DATES;
            
    END IF; 
    RSP:= 'OK';
END IF;




IF INDESCRIPTION IS NOT NULL THEN
    UPDATE V_PROCESSES SET DESCRIPTION = INDESCRIPTION
    WHERE V_PROCESSES.ID = INID;
    COMMIT;
END IF;


IF IND_PUBLISH IS NOT NULL THEN
    UPDATE V_PROCESSES SET D_PUBLISH = TO_DATE(IND_PUBLISH,'DD/MM/YYYY')
    WHERE V_PROCESSES.ID = INID;
    COMMIT;
END IF;

IF IND_START IS NOT NULL THEN
    UPDATE V_PROCESSES SET D_START = TO_DATE(IND_START,'DD/MM/YYYY')
    WHERE V_PROCESSES.ID = INID;
    COMMIT;
END IF;

IF IND_END IS NOT NULL THEN
    UPDATE V_PROCESSES SET D_END = TO_DATE(IND_END,'DD/MM/YYYY')
    WHERE V_PROCESSES.ID = INID;
    COMMIT;
END IF;

IF INPRESIDENT_NAME IS NOT NULL THEN
    UPDATE V_PROCESSES SET PRESIDENT_NAME = INPRESIDENT_NAME
    WHERE V_PROCESSES.ID = INID;
    COMMIT;
END IF;

IF INURL IS NOT NULL THEN
    UPDATE V_PROCESSES SET URL = INURL
    WHERE V_PROCESSES.ID = INID;
    COMMIT;
END IF;

INSERT_LOG_PROCEDURES('UPDATE_PROCESSES',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN WRONG_DATES THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('UPDATE_PROCESSES',SINPUT,'ERR','Y',SMSG);
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999,SMSG);

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('UPDATE_PROCESSES',SINPUT,'ERR','Y','NO ROWS UPDATED');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'NO ROWS UPDATED');


WHEN OTHERS THEN
INSERT_LOG_PROCEDURES('UPDATE_PROCESSES',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_REL_CENS_PROC
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_REL_CENS_PROC" (INID_PROCESS IN NUMBER, INID_STATE IN NUMBER,
INID_REGION IN NUMBER, INID_LOCALITY IN NUMBER,
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID_PROCESS, SAUX); 
SINPUT := CONCAT(SINPUT,INID_STATE);SINPUT := CONCAT(SINPUT,SAUX);
SINPUT := CONCAT(SINPUT,INID_REGION);SINPUT := CONCAT(SINPUT,SAUX);
SINPUT := CONCAT(SINPUT,INID_LOCALITY);

INSERT INTO VOTINGEUROPE.V_REL_CENS_PROC (
   ID_PROCESS, ID_STATE, 
   ID_REGION, ID_LOCALITY) 
VALUES (
  INID_PROCESS ,
  INID_STATE ,
  INID_REGION ,
  INID_LOCALITY );
  
COMMIT;
    INSERT_LOG_PROCEDURES('INSERT_REL_CENS_PROC',SINPUT,'OK','N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_REL_CENS_PROC',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_APPLICATION
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_APPLICATION" (INID IN NUMBER, INDESCRIPTION IN VARCHAR2, 
INCONTACT_PERSON IN VARCHAR2, INDETAILS IN VARCHAR2, INADDED_DOCS IN BLOB, INRESPONSIBLE IN VARCHAR2, 
INRESP_ADRESS IN VARCHAR2, INRESP_PHONE IN NUMBER, INRESP_EMAIL IN VARCHAR2,
RSP OUT VARCHAR)
IS 

NOT_FOUND EXCEPTION;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INDESCRIPTION);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INCONTACT_PERSON);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDETAILS);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESPONSIBLE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESP_ADRESS);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESP_PHONE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INRESP_EMAIL);

IF INDESCRIPTION IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET DESCRIPTION = INDESCRIPTION
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;

IF INCONTACT_PERSON IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET CONTACT_PERSON = INCONTACT_PERSON
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;

IF INDETAILS IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET DETAILS = INDETAILS
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;

IF INADDED_DOCS IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET ADDED_DOCS = INADDED_DOCS
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;


IF INRESPONSIBLE IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET RESPONSIBLE = INRESPONSIBLE
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;

IF INRESP_ADRESS IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET RESP_ADDRESS = INRESP_ADRESS
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;


IF INRESP_PHONE IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET RESP_PHONE = INRESP_PHONE
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;


IF INRESP_EMAIL IS NOT NULL THEN
    UPDATE V_APPLICATIONS SET RESP_EMAIL = INRESP_EMAIL
    WHERE V_APPLICATIONS.ID = INID;
    COMMIT;
END IF;


IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('UPDATE_APPLICATION',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';


EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('UPDATE_APPLICATION',SINPUT,'ERR','Y','NO ROWS UPDATED');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'NO ROWS UPDATED');


WHEN OTHERS THEN
INSERT_LOG_PROCEDURES('UPDATE_APPLICATION',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_PAIS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_PAIS" (INIDPAIS IN NUMBER, ISOCODE IN VARCHAR2, SDESC IN VARCHAR2, SOWN IN VARCHAR2,
RSP OUT VARCHAR)
IS 

NOT_FOUND EXCEPTION;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INIDPAIS, SAUX);
SINPUT := CONCAT(SINPUT,ISOCODE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,SDESC);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,SOWN);


IF ISOCODE IS NOT NULL THEN
    UPDATE V_STATES SET ISO_CODE = ISOCODE
    WHERE V_STATES.ID = INIDPAIS;
    COMMIT;
END IF;


IF SDESC IS NOT NULL THEN
    UPDATE V_STATES SET DESCRIPTION = SDESC
    WHERE V_STATES.ID = INIDPAIS;
    COMMIT;
END IF;

IF TRIM(SOWN) IS NOT NULL THEN
    UPDATE V_STATES SET NAME_OWN_LANGUAGE = SOWN
    WHERE V_STATES.ID = INIDPAIS;
    COMMIT;
END IF;

IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('UPDATE_PAIS',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('UPDATE_PAIS',SINPUT,'ERR','Y','NO ROWS UPDATED');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'NO ROWS UPDATED');


WHEN OTHERS THEN
INSERT_LOG_PROCEDURES('UPDATE_PAIS',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_LOCALITIES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_LOCALITIES" (INID IN NUMBER, INID_STATE IN NUMBER, 
INID_REGION IN NUMBER, INDESCRIPTION IN VARCHAR2,
RSP OUT VARCHAR)
IS 

NOT_FOUND EXCEPTION;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);


BEGIN

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INID_STATE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INID_REGION);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDESCRIPTION);


IF INID_STATE IS NOT NULL THEN
    UPDATE V_LOCALITIES SET ID_STATE = INID_STATE
    WHERE V_LOCALITIES.ID = INID;
    COMMIT;
END IF;

IF INID_REGION IS NOT NULL THEN
    UPDATE V_LOCALITIES SET ID_REGION = INID_REGION
    WHERE V_LOCALITIES.ID = INID;
    COMMIT;
END IF;

IF INDESCRIPTION IS NOT NULL THEN
    UPDATE V_LOCALITIES SET DESCRIPTION = INDESCRIPTION
    WHERE V_LOCALITIES.ID = INID;
    COMMIT;
END IF;


IF SQL%NOTFOUND THEN
    RAISE NOT_FOUND;
END IF;

INSERT_LOG_PROCEDURES('UPDATE_LOCALITIES',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('UPDATE_LOCALITIES',SINPUT,'ERR','Y','NO ROWS UPDATED');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'NO ROWS UPDATED');


WHEN OTHERS THEN
INSERT_LOG_PROCEDURES('UPDATE_LOCALITIES',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_REGIONS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_REGIONS" (INID IN NUMBER, INID_STATE IN NUMBER, 
INID_REGION IN NUMBER, INDESCRIPTION IN VARCHAR2,
RSP OUT VARCHAR)
IS 

NOT_FOUND EXCEPTION;

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID, SAUX);
SINPUT := CONCAT(SINPUT,INID_STATE);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INID_REGION);
SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INDESCRIPTION);



IF INID_STATE IS NOT NULL THEN
    UPDATE V_REGIONS SET ID_STATE = INID_STATE
    WHERE V_REGIONS.ID = INID;
    COMMIT;
END IF;

IF INDESCRIPTION IS NOT NULL THEN
    UPDATE V_REGIONS SET DESCRIPTION = INDESCRIPTION
    WHERE V_REGIONS.ID = INID;
    COMMIT;
END IF;

INSERT_LOG_PROCEDURES('UPDATE_REGIONS',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN NOT_FOUND THEN
    INSERT_LOG_PROCEDURES('UPDATE_REGIONS',SINPUT,'ERR','Y','NO ROWS UPDATED');
    COMMIT;
    RSP := 'ERR';
    RAISE_APPLICATION_ERROR (-20999, 'NO ROWS UPDATED');


WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('UPDATE_REGIONS',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
    
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_STATES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_STATES" (INISO_CODE IN VARCHAR2, INDESCRIPTION IN VARCHAR2,
INNAME_OWN_LANGUAGE IN VARCHAR2,
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INISO_CODE, SAUX); 
SINPUT := CONCAT(SINPUT,INDESCRIPTION);SINPUT := CONCAT(SINPUT,SAUX);
SINPUT := CONCAT(SINPUT,INNAME_OWN_LANGUAGE);

INSERT INTO VOTINGEUROPE.V_STATES (
   ISO_CODE, DESCRIPTION, 
   NAME_OWN_LANGUAGE) 
VALUES (
  INISO_CODE ,
  INDESCRIPTION ,
  INNAME_OWN_LANGUAGE  );
  
COMMIT;
    INSERT_LOG_PROCEDURES('INSERT_STATES',SINPUT,'OK','N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_STATES',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure UPDATE_RESULTS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."UPDATE_RESULTS" (RSP OUT VARCHAR2)
IS 
 IDAPP NUMBER;
 IDAPPLESS NUMBER;
 NUM NUMBER;
 TOTVOTWINNER NUMBER;
 TOTVOTES NUMBER;
 TOTCIT NUMBER;
 TOTVOTLESS NUMBER;
 --CSTATUS VARCHAR2(100);
 MAXIDPROC NUMBER;
 RSPAUX VARCHAR2(100);


BEGIN
-- INSERT MISSING IDS
INSERT INTO V_R_RESULTS 
(SELECT ID, NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL FROM V_PROCESSES WHERE ID NOT IN (SELECT ID FROM V_R_RESULTS));

-- LOOK FOR MAX ID OF PROCESSES

SELECT MAX(ID) INTO MAXIDPROC FROM V_PROCESSES;


    NUM:=1;

    FOR NUM IN 1..MAXIDPROC
    LOOP
 
    --LOOK FOR WINNER ID
    IDAPP:= F_WINNER_OPTION(NUM,RSPAUX);
    IDAPPLESS := F_LOWER_OPTION(NUM,RSPAUX);


    IF IDAPP = 0 OR IDAPPLESS = 0 THEN
    TOTVOTWINNER := 0;
    TOTVOTLESS := 0;
    TOTVOTES:= 0;
    TOTCIT:=0;
    
    ELSE
    -- LOOK FOR TOTAL VOTES OF WINNER ID   
    SELECT COUNT(ID) INTO TOTVOTWINNER FROM V_VOTES 
    WHERE APPLICATION_ID = IDAPP
    AND PROCESS_ID = NUM;
    
     --SELECT TOTAL CITIZENS IN ALL CENSUS
    SELECT TOTAL_CITIZENS INTO TOTCIT FROM VIEW_R6_2 WHERE ID_PROCESS = NUM;
    
    --LOOK FOR VOTES OF LOWER OPTION
    SELECT COUNT(ID) INTO TOTVOTLESS FROM V_VOTES 
    WHERE APPLICATION_ID = IDAPPLESS
    AND PROCESS_ID = NUM;
    
    --SELECT TOTAL VOTES OF THE PROCESS
    
    SELECT COUNT(ID) INTO TOTVOTES FROM V_VOTES WHERE PROCESS_ID = NUM;
    -- UPDTATE ID WINNER
    END IF;  
    
    UPDATE V_R_RESULTS SET ID_WINNER = IDAPP,
    TOTAL_CITIZENS = TOTCIT,
    PARTICIPATION = TOTVOTES/TOTCIT,
    --STATUS = CSTATUS,
    PORC_WINNER = TOTVOTWINNER/TOTVOTES,
    ID_LESS  = IDAPPLESS,  
    PORC_LESS = TOTVOTLESS/TOTVOTES,
    DIFF_MAX_MIN = PORC_WINNER - PORC_LESS
    WHERE ID_PROCESS = NUM;

    END LOOP;
    
    --UPDATE STATUS OF ALL OF ALL OF THE PROCESSES
    UPDATE V_R_RESULTS A SET A.STATUS = (SELECT STATUS FROM VIEW_R6_1 WHERE ID = A.ID_PROCESS);

    RSP := RSPAUX;
    INSERT_LOG_PROCEDURES('UPDATE_RESULTS','-',RSPAUX,'N','-');
    

EXCEPTION 
WHEN OTHERS THEN
    INSERT_LOG_PROCEDURES('UPDATE_RESULTS','-','ERR','Y',SQLERRM);
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_REL_APPL_PROC
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_REL_APPL_PROC" (INID_APPLICATION IN NUMBER, INID_PROCESS IN NUMBER,
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID_APPLICATION, SAUX); SINPUT := CONCAT(SINPUT,INID_PROCESS);

INSERT INTO VOTINGEUROPE.V_REL_APPL_PROC (
    ID_APPLICATION, ID_PROCESS) 
VALUES (
  INID_APPLICATION ,
  INID_PROCESS );
  
COMMIT;
    INSERT_LOG_PROCEDURES('INSERT_REL_APPL_PROC',SINPUT,'OK','N','-');
    COMMIT;
    RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
    DBMS_OUTPUT.PUT_LINE(SQLERRM);
    ROLLBACK;
    INSERT_LOG_PROCEDURES('INSERT_REL_APPL_PROC',SINPUT,'ERR','Y',SQLERRM);
    COMMIT;
    RSP := 'ERR';
END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_LOG_PROCEDURES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_LOG_PROCEDURES" (INNAME IN VARCHAR2, ININPUT IN VARCHAR2, INOUTPUT IN VARCHAR2, 
SERR IN VARCHAR2, SDESCERR IN VARCHAR2)
IS 

BEGIN

INSERT INTO VOTINGEUROPE.V_LOG_PROCEDURES (
   PROC_NAME, S_INPUT, 
   S_OUTPUT, ERR, DESC_ERR, TIME_EXEC) 
VALUES (
  INNAME ,
  ININPUT ,
  INOUTPUT ,
  SERR,
  SDESCERR,
  SYSDATE
  );
  
DBMS_OUTPUT.PUT_LINE('INSERT OK');

EXCEPTION WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE(SQLERRM);

END;

/
--------------------------------------------------------
--  DDL for Procedure INSERT_LOG_VOTING
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "VOTINGEUROPE"."INSERT_LOG_VOTING" (INID_PROCESS IN NUMBER, INID_CENSUS IN NUMBER,
IND_VOTING IN DATE, INSTATUS IN VARCHAR2, 
RSP OUT VARCHAR)
IS 

SAUX VARCHAR(3):= ' , ';
SINPUT VARCHAR2(4000);

BEGIN

SINPUT := CONCAT(INID_PROCESS, SAUX);
SINPUT := CONCAT(SINPUT,INID_CENSUS);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,IND_VOTING);SINPUT := CONCAT(SINPUT, SAUX);
SINPUT := CONCAT(SINPUT,INSTATUS);

INSERT INTO VOTINGEUROPE.V_LOG_VOTING (
   ID_PROCESS, ID_CENSUS, 
   D_VOTING, STATUS) 
VALUES (
  INID_PROCESS ,
  INID_CENSUS ,
  IND_VOTING ,
  INSTATUS );
  
COMMIT;
INSERT_LOG_PROCEDURES('INSERT_INSERT_LOG_VOTING',SINPUT,'OK','N','-');
COMMIT;
RSP := 'OK';

EXCEPTION 

WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE(SQLERRM);
ROLLBACK;

INSERT_LOG_PROCEDURES('INSERT_INSERT_LOG_VOTING',SINPUT,'ERR','Y',SQLERRM);
COMMIT;
RSP := 'ERR';
END;

/
